function vRev = convertIrrevFluxDistribution(vIrrev,matchRev)
%convertInrrevFluxDistribution  Convert irreversible flux distribution to
%reversible
%
% vRev = covertIrrevFluxDistribution(vIrrev,matchRev)
%
%INPUTS
% vIrrev        Irreversible flux distribution
% matchRev      Vector mapping irreversible fluxes to reversible fluxes 
%               (Generated by convertToIrreversible)
%
%OUTPUT
% vRev          Reversible flux distribution
%
% Markus Herrgard 1/30/07

processedFlux = false*ones(length(vIrrev),1);

vRev = [];

for i = 1:length(vIrrev)
    if (~processedFlux(i))
        if (matchRev(i) > 0)
            vRev(end+1) = vIrrev(i)-vIrrev(matchRev(i));
            processedFlux(matchRev(i)) = true;
        else
            vRev(end+1) = vIrrev(i);
        end
        processedFlux(i) = true;
    end
end

vRev = columnVector(vRev);